#!/bin/bash

## Getting EMACS fro CVS
##
## cd /tmp
## cvs -z3 -d:pserver:anonymous@cvs.savannah.gnu.org:/sources/emacs co -P emacs
##
## or
##
## cvs -z3 -d:pserver:anonymous@cvs.savannah.gnu.org:/cvsroot/emacs co -P emacs
##
## find emacs \! -type d | tar cjfT emacs-22.0.50-cvs-src.tar.bz2 -
##
## or
##
## tar -cjvf emacs-22.0.50-cvs-src.tar.bz2 emacs

## Current time
DATE=`date +%Y%m%d_%H%M%S`
PWD_DIR=`pwd`

{

#export PATH=/usr/local/gcc-3.4.4-1-1/bin::.:$PATH
#gcc -v

rel="22.0.50"

PKG_DIR="/home/$USER/Downloads/cygwin_varie/emacs-cvs"

base_dir="${PWD_DIR}"
source_dir="${base_dir}/emacs"
build_dir="${source_dir}/.build"
dest_dir="${source_dir}/.inst"

prefix_dir_name="usr/local/emacs-${rel}"
prefix_dir="/${prefix_dir_name}"

cd ${base_dir}
# echo ""
# echo "Unpacking the source..."
# tar -xjf ${PKG_DIR}/emacs-${rel}-cvs-src.tar.bz2

mkdir -p ${dest_dir} ${build_dir}

cd ${build_dir}

echo ""
echo "Configuring..."
#LDFLAGS='-Wl,--enable-auto-import -Wl,--enable-auto-image-base' \
../configure --prefix=${prefix_dir}

echo ""
echo "Making the bootstrap..."
# make bootstrap LD='$(CC) -Wl,--enable-auto-import -Wl,--enable-auto-image-base'
make bootstrap

make install prefix=${dest_dir}/${prefix_dir_name}

# Assuming /usr/spool/mail is really the mail spool directory, you should
# run

# lib-src/blessmail ${dest_dir}/${prefix_dir_name}/libexec/emacs/${rel}/i686-pc-cygwin/movemail.exe

# as root, to give movemail.exe appropriate permissions.
# Do that after running make install.

echo ""
echo "Making the binary package..."
cd ${dest_dir}

# find ${prefix_dir_name} -name "*.exe"  | xargs strip -s -p

find ${prefix_dir_name} \! -type d | tar cjfT ${base_dir}/emacs-${rel}-cvs.tar.bz2 -

# Installation
#
# cd /
# tar -xjvf ${base_dir}/emacs-${rel}-cvs.tar.bz2

# cd /usr/local/bin

# ln -sf /usr/local/emacs-${rel}/bin/emacs.exe emacs-cvs

# cd /tmp
# emacs-cvs &

} 2>&1 | tee build-emacs-cvs-$DATE.log

#shutdown.exe -x 120
